<?php

namespace CustomerManagement\ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for Delete ServiceType
 * @subpackage Services
 */
class Delete extends AbstractSoapClientBase
{
    /**
     * Sets the Authentication SoapHeader param
     * @uses AbstractSoapClientBase::setSoapHeader()
     * @param \CustomerManagement\StructType\Authentication $authentication
     * @param string $nameSpace
     * @param bool $mustUnderstand
     * @param string $actor
     * @return bool
     */
    public function setSoapHeaderAuthentication(\CustomerManagement\StructType\Authentication $authentication, $nameSpace = 'http://www.alarm.com/WebServices', $mustUnderstand = false, $actor = null)
    {
        return $this->setSoapHeader($nameSpace, 'Authentication', $authentication, $mustUnderstand, $actor);
    }
    /**
     * Method to call the operation originally named DeleteCustomerWebsiteMessage
     * Meta information extracted from the WSDL
     * - SOAPHeaderNames: Authentication
     * - SOAPHeaderNamespaces: http://www.alarm.com/WebServices
     * - SOAPHeaderTypes: \CustomerManagement\StructType\Authentication
     * - SOAPHeaders: required
     * - documentation: Delete a customer website message.
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \CustomerManagement\StructType\DeleteCustomerWebsiteMessage $parameters
     * @return \CustomerManagement\StructType\DeleteCustomerWebsiteMessageResponse|bool
     */
    public function DeleteCustomerWebsiteMessage(\CustomerManagement\StructType\DeleteCustomerWebsiteMessage $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->DeleteCustomerWebsiteMessage($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named DeleteSensorDevice
     * Meta information extracted from the WSDL
     * - SOAPHeaderNames: Authentication
     * - SOAPHeaderNamespaces: http://www.alarm.com/WebServices
     * - SOAPHeaderTypes: \CustomerManagement\StructType\Authentication
     * - SOAPHeaders: required
     * - documentation: Remove sensor device.
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \CustomerManagement\StructType\DeleteSensorDevice $parameters
     * @return \CustomerManagement\StructType\DeleteSensorDeviceResponse|bool
     */
    public function DeleteSensorDevice(\CustomerManagement\StructType\DeleteSensorDevice $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->DeleteSensorDevice($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named DeleteImageSensor
     * Meta information extracted from the WSDL
     * - SOAPHeaderNames: Authentication
     * - SOAPHeaderNamespaces: http://www.alarm.com/WebServices
     * - SOAPHeaderTypes: \CustomerManagement\StructType\Authentication
     * - SOAPHeaders: required
     * - documentation: Remove Image Sensor.
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \CustomerManagement\StructType\DeleteImageSensor $parameters
     * @return \CustomerManagement\StructType\DeleteImageSensorResponse|bool
     */
    public function DeleteImageSensor(\CustomerManagement\StructType\DeleteImageSensor $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->DeleteImageSensor($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named DeleteVideoDevice
     * Meta information extracted from the WSDL
     * - SOAPHeaderNames: Authentication
     * - SOAPHeaderNamespaces: http://www.alarm.com/WebServices
     * - SOAPHeaderTypes: \CustomerManagement\StructType\Authentication
     * - SOAPHeaders: required
     * - documentation: Delete Video Device.
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \CustomerManagement\StructType\DeleteVideoDevice $parameters
     * @return \CustomerManagement\StructType\DeleteVideoDeviceResponse|bool
     */
    public function DeleteVideoDevice(\CustomerManagement\StructType\DeleteVideoDevice $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->DeleteVideoDevice($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named
     * DeletePendingZwaveDeviceSpecificKey
     * Meta information extracted from the WSDL
     * - SOAPHeaderNames: Authentication
     * - SOAPHeaderNamespaces: http://www.alarm.com/WebServices
     * - SOAPHeaderTypes: \CustomerManagement\StructType\Authentication
     * - SOAPHeaders: required
     * - documentation: Delete a pending Z-Wave device specific key (DSK) for a customer.
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \CustomerManagement\StructType\DeletePendingZwaveDeviceSpecificKey $parameters
     * @return \CustomerManagement\StructType\DeletePendingZwaveDeviceSpecificKeyResponse|bool
     */
    public function DeletePendingZwaveDeviceSpecificKey(\CustomerManagement\StructType\DeletePendingZwaveDeviceSpecificKey $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->DeletePendingZwaveDeviceSpecificKey($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named DeleteCustomerLogin
     * Meta information extracted from the WSDL
     * - SOAPHeaderNames: Authentication
     * - SOAPHeaderNamespaces: http://www.alarm.com/WebServices
     * - SOAPHeaderTypes: \CustomerManagement\StructType\Authentication
     * - SOAPHeaders: required
     * - documentation: Delete a login from a customer account.
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \CustomerManagement\StructType\DeleteCustomerLogin $parameters
     * @return \CustomerManagement\StructType\DeleteCustomerLoginResponse|bool
     */
    public function DeleteCustomerLogin(\CustomerManagement\StructType\DeleteCustomerLogin $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->DeleteCustomerLogin($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \CustomerManagement\StructType\DeleteCustomerLoginResponse|\CustomerManagement\StructType\DeleteCustomerWebsiteMessageResponse|\CustomerManagement\StructType\DeleteImageSensorResponse|\CustomerManagement\StructType\DeletePendingZwaveDeviceSpecificKeyResponse|\CustomerManagement\StructType\DeleteSensorDeviceResponse|\CustomerManagement\StructType\DeleteVideoDeviceResponse
     */
    public function getResult()
    {
        return parent::getResult();
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
